import { DownOutline, UpOutline } from "antd-mobile-icons";
import { useState } from "react";
export default function (props) {
  const [open, setOpen] = useState(false);
  return (
    <div>
      <div
        style={{
          display: "flex",
          justifyContent: "space-between",
          alignItems: "center",
          ...props.style,
        }}
      >
        {props.title}
        <div style={{ display: "flex", alignItems: "center", gap: 12 }}>
          <div
            style={{
              fontWeight: "800",
              fontSize: 18,
              color: "#ffffff",
            }}
          >
            {props.value}
          </div>
          {open ? (
            <UpOutline
              fontSize={24}
              color="#fff"
              onClick={() => setOpen(!open)}
            />
          ) : (
            <DownOutline
              color="#fff"
              fontSize={24}
              onClick={() => setOpen(!open)}
            />
          )}
        </div>
      </div>
      {open ? props.children : null}
    </div>
  );
}
