import styles from "./index.module.css";
import icon3 from "@/assets/images/icon3.png";
import demoData from "../IndexSystemDetail/demoData.json";
import demoData2 from "../IndexSystemDetail/demoData2.json";

import { useMemo } from "react";
import Collapse from "../../components/collapse";
export default function () {
  const columns = [
    {
      title: "指标名称",
      dataIndex: "a",
      render: (record) => {
        return (
          <div
            style={{
              fontWeight: "800",

              fontSize: 14,
              color: "#434A62",
            }}
          >
            {record["a"]}
          </div>
        );
      },
      width: "30%",
    },
    {
      title: "立案条件",
      dataIndex: "b",
      width: "40%",
      render: (record) => {
        return (
          <div
            style={{
              fontWeight: "400",
              textAlign: "left",
              fontSize: 12,
              color: "#434A62",
            }}
          >
            {record["b"]}
          </div>
        );
      },
    },
    {
      title: "指标权重",
      dataIndex: "c",
      width: "20%",
    },

    {
      title: "分值",
      dataIndex: "d",

      width: "10%",
    },
  ];
  const columns1 = [
    {
      title: "指标名称",
      dataIndex: "a",
      render: (record) => {
        return (
          <div
            style={{
              fontWeight: "800",
              textAlign: "left",
              fontSize: 14,
              color: "#434A62",
            }}
          >
            {record["a"]}
          </div>
        );
      },
      width: "60%",
    },

    {
      title: "指标权重",
      dataIndex: "b",
      width: "30%",
    },
    {
      title: "分值",
      width: "10%",
      dataIndex: "d",
    },
  ];

  const columns2 = [
    {
      title: "指数名称",
      dataIndex: "a",
      render: (record) => {
        return (
          <div
            style={{
              fontWeight: "800",
              textAlign: "left",
              fontSize: 14,
              color: "#434A62",
            }}
          >
            {record["a"]}
          </div>
        );
      },
      width: "70%",
    },

    {
      title: "权重系数",
      dataIndex: "b",
      width: "30%",
    },
  ];
  const demo1 = [
    {
      a: "城管管理指数（目标导向）",
      b: "0.4",
    },
    {
      a: "城管管理指数（问题导向）",
      b: "0.3",
    },
    {
      a: "城管康复指数（效能导向）",
      b: "0.3",
    },
  ];

  const dataSource = useMemo(() => {
    return demoData.map((cur) => {
      const descList = cur.类别合并.split("|");

      return {
        a: descList.at(-2),
        b: descList.at(-1),
        c: cur.以井盖缺失为单位1的权重,
        d: -(0.003 + Math.random() * (0.01 - 0.003)).toFixed(3),
      };
    });
  }, []);

  const dataSource2 = useMemo(() => {
    return demoData.map((cur) => {
      const descList = cur.类别合并.split("|");

      return {
        a: descList.at(-2),
        b: descList.at(-1),
        c: cur.以井盖缺失为单位1的权重,
        d: (0.003 + Math.random() * (0.01 - 0.003)).toFixed(3),
      };
    });
  }, []);

  const dataSource1 = useMemo(() => {
    return demoData2.map((v) => {
      return {
        a: v.四级指标,
        b: (Math.random() * 0.2 + 0.8).toFixed(2),
        d: (0.003 + Math.random() * (0.01 - 0.003)).toFixed(3),
      };
    });
  }, []);
  return (
    <div className={styles.container}>
      {/* <div className={styles.title}>城市管理综合指数</div> */}
      <div className={styles.calculationFormulaWrap}>
        <div className={styles.calculationFormulaHeader}>
          <div style={{ display: "flex", alignItems: "center", gap: 8 }}>
            <img src={icon3} style={{ width: 38, height: 38 }}></img>
            <div
              style={{
                fontSize: 19,
                color: "rgba(31, 133, 255, 1)",
              }}
            >
              城市管理综合指数CQI
            </div>
          </div>
          <div
            style={{
              color: "#09c35c",
              fontSize: 20,
              fontWeight: "700",
            }}
          >
            95.5
          </div>
        </div>
        <div className={styles.formulaBox}>
          <div className={styles.formulaBox_title}>计算公式：</div>
          <div className={styles.formulaBox_content}>
            CQI = CDIWC × CDI + CPIWC × CPI + CRIWC × CRI
          </div>
          <div className={styles.formulaBox_desc}>
            <div>CDI：城管管理指数（目标导向）</div>
            <div> CPI：城管管理指数（问题导向）</div>
            <div> CRI：城管康复指数（效能导向）</div>
            <div> CDIWC：城管管理指数（目标导向）权重系数</div>
            <div> CPIWC：城管管理指数（问题导向）权重系数</div>
            <div> CRIWC：城管康复指数（效能导向）权重系数</div>
          </div>
        </div>
      </div>

      <div className={styles.contentWrap}>
        <div className={styles.subTitle}>
          <div>指标体系</div>
        </div>
        <div>
          <div className={styles.Table}>
            <div className={styles.header}>
              {columns2.map((item) => (
                <div
                  key={item.title}
                  className={styles.cell1}
                  style={{ width: item.width }}
                >
                  {item.title}
                </div>
              ))}
            </div>
            <div className={styles.tableBody}>
              {demo1.map((item, index) => (
                <div className={styles.row} key={index}>
                  {columns2.map((headerItem) => (
                    <div
                      key={headerItem.title + index}
                      className={styles.bodyCell}
                      style={{ width: headerItem.width }}
                    >
                      {headerItem.render
                        ? headerItem.render(item, index)
                        : item[headerItem.dataIndex]}
                    </div>
                  ))}
                </div>
              ))}
            </div>
          </div>
        </div>
        <Collapse
          style={{ marginTop: 20 }}
          value={"CDI 96.3"}
          title={
            <div className={styles.subTitle}>
              <div>城市管理指标(目标导向)</div>
              <div className={styles.numbers1}>{dataSource1.length}项</div>
            </div>
          }
        >
          <div>
            <div className={styles.Table}>
              <div className={styles.header}>
                {columns1.map((item) => (
                  <div
                    key={item.title}
                    className={styles.cell}
                    style={{ width: item.width }}
                  >
                    {item.title}
                  </div>
                ))}
              </div>
              <div className={styles.tableBody}>
                {dataSource1.map((item, index) => (
                  <div className={styles.row} key={index}>
                    {columns1.map((headerItem) => (
                      <div
                        key={headerItem.title + index}
                        className={styles.bodyCell}
                        style={{ width: headerItem.width }}
                      >
                        {headerItem.render
                          ? headerItem.render(item, index)
                          : item[headerItem.dataIndex]}
                      </div>
                    ))}
                  </div>
                ))}
              </div>
            </div>
          </div>
        </Collapse>
        <Collapse
          style={{ marginTop: 20 }}
          value={"CPI 93.2"}
          title={
            <div className={styles.subTitle}>
              <div>城市问题指标(问题导向)</div>
              <div className={styles.numbers}>387项</div>
            </div>
          }
        >
          <div>
            <div className={styles.Table}>
              <div className={styles.header}>
                {columns.map((item) => (
                  <div
                    key={item.title}
                    className={styles.cell}
                    style={{ width: item.width }}
                  >
                    {item.title}
                  </div>
                ))}
              </div>
              <div className={styles.tableBody}>
                {dataSource2.map((item, index) => (
                  <div className={styles.row} key={index}>
                    {columns.map((headerItem) => (
                      <div
                        key={headerItem.title + index}
                        className={styles.bodyCell}
                        style={{ width: headerItem.width }}
                      >
                        {headerItem.render
                          ? headerItem.render(item, index)
                          : item[headerItem.dataIndex]}
                      </div>
                    ))}
                  </div>
                ))}
              </div>
            </div>
          </div>
        </Collapse>
        <Collapse
          style={{ marginTop: 20 }}
          value={"CRI 96.7"}
          title={
            <div className={styles.subTitle}>
              <div>城市问题指标(效能导向)</div>
              <div className={styles.numbers}>387项</div>
            </div>
          }
        >
          <div>
            <div className={styles.Table}>
              <div className={styles.header}>
                {columns.map((item) => (
                  <div
                    key={item.title}
                    className={styles.cell}
                    style={{ width: item.width }}
                  >
                    {item.title}
                  </div>
                ))}
              </div>
              <div className={styles.tableBody}>
                {dataSource.map((item, index) => (
                  <div className={styles.row} key={index}>
                    {columns.map((headerItem) => (
                      <div
                        key={headerItem.title + index}
                        className={styles.bodyCell}
                        style={{ width: headerItem.width }}
                      >
                        {headerItem.render
                          ? headerItem.render(item, index)
                          : item[headerItem.dataIndex]}
                      </div>
                    ))}
                  </div>
                ))}
              </div>
            </div>
          </div>
        </Collapse>

        <div style={{ height: 100 }}></div>
      </div>
    </div>
  );
}
