import styles from "./index.module.css";
import icon2 from "@/assets/images/icon2.png";
import demoData from "./demoData.json";
import demoData2 from "./demoData2.json";

import { useMemo } from "react";
import { useLocation } from "react-router-dom";
import Collapse from "../../components/collapse";
export default function () {
  const location = useLocation();

  const columns = [
    {
      title: "指标名称",
      dataIndex: "a",
      render: (record) => {
        return (
          <div
            style={{
              fontWeight: "800",

              fontSize: 12,
              color: "#434A62",
            }}
          >
            {record["a"]}
          </div>
        );
      },
      width: "20%",
    },
    {
      title: "立案条件",
      dataIndex: "b",
      width: "25%",
      render: (record) => {
        return (
          <div
            style={{
              fontWeight: "400",
              textAlign: "left",
              fontSize: 12,
              color: "#434A62",
            }}
          >
            {record["b"]}
          </div>
        );
      },
    },
    {
      title: "指标权重",
      dataIndex: "c",
      width: "10%",
    },
    {
      title: "问题",
      width: "15%",
      dataIndex: "d",
    },
    {
      title: "效能",
      dataIndex: "e",
      width: "15%",
    },
    {
      title: "分值",
      dataIndex: "f",
      width: "15%",
    },
  ];
  const columns1 = [
    {
      title: "指标名称",
      dataIndex: "a",
      render: (record) => {
        return (
          <div
            style={{
              fontWeight: "800",
              textAlign: "left",
              fontSize: 12,
              color: "#434A62",
            }}
          >
            {record["a"]}
          </div>
        );
      },
      width: "60%",
    },

    {
      title: "指标权重",
      dataIndex: "b",
      width: "20%",
    },
    {
      title: "扣分",
      width: "10%",
      dataIndex: "d",
    },
  ];

  const typeInfo = useMemo(() => {
    const params = new URLSearchParams(location.search);
    const id = params.get("id") ?? 1;
    const list = ["整洁", "有序", "便民", "安全"];
    return list[id - 1];
  }, [location]);

  const value = useMemo(() => {
    const params = new URLSearchParams(location.search);
    const id = params.get("id") ?? 1;
    const list = [
      {
        v: 95.2,
        a: 47.2,
        b: 48,
      },
      {
        v: 93.8,
        a: 48.7,
        b: 45.1,
      },
      {
        v: 93.2,
        a: 48.2,
        b: 45,
      },
      {
        v: 97.3,
        a: 48.2,
        b: 49.1,
      },
    ];
    return list[id - 1];
  }, [location]);

  const dataSource = useMemo(() => {
    return demoData.reduce((pre, cur) => {
      const descList = cur.类别合并.split("|");
      const v1 = -(0.03 + Math.random() * 0.02).toFixed(3);
      const v2 = (Math.random() * 0.02).toFixed(3);
      const v3 = (Number(v1) + Number(v2)).toFixed(3);
      const newStruct = {
        a: descList.at(-2),
        b: descList.at(-1),
        c: cur.以井盖缺失为单位1的权重,
        d: v1,
        e: v2,
        f: v3,
      };
      if (cur.维度 in pre) {
        pre[cur.维度].push(newStruct);
      } else {
        pre[cur.维度] = [newStruct];
      }
      return pre;
    }, {});
  }, []);

  const dataSource1 = useMemo(() => {
    return demoData2.reduce((pre, cur) => {
      const newStruct = {
        a: cur.四级指标,
        b: (Math.random() * 0.2 + 0.8).toFixed(2),
        d: (0.03 + Math.random() * 0.02).toFixed(3),
      };
      if (cur.维度 in pre) {
        pre[cur.维度].push(newStruct);
      } else {
        pre[cur.维度] = [newStruct];
      }
      return pre;
    }, {});
  }, []);

  const getStatus = (val) => {
    if (val > 95) {
      return {
        name: "理想态",
        bg: "#09c35c",
        desc: "健康状况优秀",
      };
    }
    if (val < 95 && val > 85) {
      return {
        name: "标准态",
        bg: "#0680f4",
        desc: "健康状况良好",
      };
    }
    if (val < 85) {
      return {
        name: "预警态",
        bg: "#ffa250",
        desc: "健康状况亟需改进",
      };
    }
  };
  return (
    <div className={styles.container}>
      <div className={styles.calculationFormulaWrap}>
        <div className={styles.calculationFormulaHeader}>
          <div style={{ display: "flex", alignItems: "center", gap: 8 }}>
            <img src={icon2} style={{ width: 38, height: 38 }}></img>
            <div
              style={{
                fontSize: 19,
                color: "rgba(31, 133, 255, 1)",
              }}
            >
              {typeInfo}
            </div>
          </div>

          <div>
            <span
              style={{ display: "inline-block", transform: "translateY(-2px)" }}
            >
              今日
            </span>
            <span
              style={{
                color: getStatus(value.v).bg,
                fontSize: 20,
                fontWeight: "700",
                lineHeight: 1,
                marginLeft: 4,
              }}
            >
              {value.v}
            </span>
          </div>
        </div>
        <div className={styles.formulaBox}>
          <div className={styles.formulaBox_title}>计算公式：</div>
          <div className={styles.formulaBox_content}>
            {typeInfo}={typeInfo}问题类指标分数+{typeInfo}管理类指标分数
          </div>
        </div>
      </div>
      <div className={styles.contentWrap}>
        <Collapse
          value={value.a}
          title={
            <div className={styles.subTitle}>
              <div>问题类指标</div>
              <div className={styles.numbers}>
                {dataSource[typeInfo]?.length}项
              </div>
            </div>
          }
        >
          <div>
            <div className={styles.Table}>
              <div className={styles.header}>
                {columns.map((item) => (
                  <div
                    key={item.title}
                    className={styles.cell}
                    style={{ width: item.width }}
                  >
                    {item.title}
                  </div>
                ))}
              </div>
              <div className={styles.tableBody}>
                {dataSource[typeInfo]?.map((item, index) => (
                  <div className={styles.row} key={index}>
                    {columns.map((headerItem) => (
                      <div
                        key={headerItem.title + index}
                        className={styles.bodyCell}
                        style={{ width: headerItem.width }}
                      >
                        {headerItem.render
                          ? headerItem.render(item, index)
                          : item[headerItem.dataIndex]}
                      </div>
                    ))}
                  </div>
                ))}
              </div>
            </div>
          </div>
        </Collapse>
        <Collapse
          value={value.b}
          style={{ marginTop: 24 }}
          title={
            <div className={styles.subTitle}>
              <div>管理类指标</div>
              <div className={styles.numbers1}>
                {dataSource1[typeInfo].length}项
              </div>
            </div>
          }
        >
          <div>
            <div className={styles.Table}>
              <div className={styles.header}>
                {columns1.map((item) => (
                  <div
                    key={item.title}
                    className={styles.cell}
                    style={{ width: item.width }}
                  >
                    {item.title}
                  </div>
                ))}
              </div>
              <div className={styles.tableBody}>
                {dataSource1[typeInfo].map((item, index) => (
                  <div className={styles.row} key={index}>
                    {columns1.map((headerItem) => (
                      <div
                        key={headerItem.title + index}
                        className={styles.bodyCell}
                        style={{ width: headerItem.width }}
                      >
                        {headerItem.render
                          ? headerItem.render(item, index)
                          : item[headerItem.dataIndex]}
                      </div>
                    ))}
                  </div>
                ))}
              </div>
            </div>
          </div>
        </Collapse>
      </div>
    </div>
  );
}
